<template>
  <div style="margin: 3rem">
    <el-header style="margin-top:10rem">
      <ReturnButton  :offsetArrow="17" :spanTitle="4" title="Menú de Almacén" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
      <!-- AUTOCOMPLETADO -->
      <el-col style="display: flex;
          justify-content: flex-end !important">
        <autocomplete 
          @handleSelect="handleSelect" 
          @querySearch="querySearch"  
          placeholderText="Buscar Material"
          colorOrange='true'
          :text="textSearch"
          ></autocomplete>
        <!-- <el-input prefix-icon="el-icon-search" v-model="textSearch" @input="searchEvent" style="margin:1rem 0 1rem 96%"></el-input> -->
      </el-col>

      <!-- TITULO DEL MATERIAL -->
      <el-col :offset="2" :span="20" class="bg-dark-gray " style="padding:10px 20px">
        <h3 class="text-white">{{ materialName }}</h3>
      </el-col>
    </el-header>

    <el-main style="margin: 10rem 8%">
      <!-- INFORMACION DEL MATERIAL -->
      <el-row style="margin:0 3rem">
        <el-col class="margin-Title"><span class="text-bold">Tipo de Material:</span><span style="margin:0 0.8rem"> {{ typeOfContent }}</span></el-col>
        <el-col class="margin-Title">
          <span class="text-bold"> Proveedor: </span><span style="margin:0 0.8rem"> {{ contractName }}</span>
        </el-col>
        <el-col class="margin-Title">
          <span class="text-bold" style="margin-right:0.8rem">Productora:</span>
          <span v-if="reviewObj">
            <span v-for= "(prod, h) in productora" :key="h">
              <span >{{prod.prodCompany}}</span>
              <!-- <span v-else style="margin-right:1rem">{{prod.prodCompany}}</span> -->
            </span>
          </span>
        </el-col>

        <!-- SELECT DEL MATERIAL CUANDO TIENE TEMPORADAS -->
        <el-col v-if="materialS.numChapters ? materialS.numChapters.length > 0 : false " style="margin-top:2rem">
          <el-select v-model="filterSelect" placeholder="Temporada" size="small" clearable>
            <el-option
              v-for="aSeason in arrSeason"
              :key="aSeason.value"
              :label="aSeason.label"
              :value="aSeason.value">
            </el-option>
          </el-select>
        </el-col>
      </el-row>
      <h4 style="margin: 3rem 1rem 1rem" class="text-orange">RECEPCIÓN DEL MATERIAL</h4>
      <div style="margin:2rem 1rem">
        <!-- TABLA DE RECEPCION DE MATERIALES CON CAPÍTULO -->

        <el-table
          :data="materialsData"
          :header-cell-class-name="headerCellClassName"   
          border
          max-height="250" min-height="100">
          <el-table-column v-if="materialS.numChapters ? materialS.numChapters.length > 0 : false"
            prop="chapter"
            label="CAPÍTULO">
          </el-table-column>
          <el-table-column label="FECHA DE LLEGADA" prop="arrivalDate">
          </el-table-column>
          <el-table-column prop="shippingMode" label="MODO DE ENVÍO" ></el-table-column>
          <el-table-column prop="arrivalSupport" label="SOPORTE DE LLEGADA"></el-table-column>
          <el-table-column label="REPOSICIÓN">
            <template slot-scope="scope">
              <div v-if="scope.row.showreplace == 'REPOSICIÓN'" >
                <el-button  size="mini" type="success"  plain  @click="showTableRepo(scope.row)" >DETALLES </el-button> 
              </div>
            </template>
          </el-table-column>
        </el-table>

        <el-dialog :visible.sync="dialogTableVisible" width="65%">
          <div style="margin:1rem 0 2rem"  >
            <h3 class="bolt-light"> <span class="text-red"> REPOSICIÓN -  </span> {{ materialS.originalTitle }}  </h3> 
          </div>
          <el-table :data="detallesByCap.reposicion" border :header-cell-class-name="headerCellClassName">
            <el-table-column 
              v-if="whatTypeContentIsDifferent"
              prop="chapter" label="CAPÍTULO" fixed>
              <template slot-scope="scope">
                <div>  {{ detallesByCap.chapter }} </div>  
              </template>
            </el-table-column>
            
            <el-table-column label="ESTADO">
              <template slot-scope="scope">
                <div>  {{ detallesByCap.showreplace }} </div>  
              </template>
            </el-table-column>
            <el-table-column label="FECHA DE LLEGADA">
              <template slot-scope="scope">
                <div v-if="scope.row.arrivalDate">{{ transformDate(scope.row.arrivalDate) }} </div> 
                <div v-else> No ingresado </div>
              </template>
            </el-table-column>
            <el-table-column property="shippingMode" label="MODO DE ENVÍO"></el-table-column>
            <el-table-column property="arrivalSupport" label="SOPORTE"></el-table-column>
          </el-table>
        </el-dialog>
      </div>

      <h4 style="margin: 4rem 1rem 1rem" class="text-orange">ALMACENAMIENTO DEL MATERIAL</h4>
      <div style="margin:2rem 1rem">
        <el-table
          :data="materialsData"
          :header-cell-class-name="headerCellClassName"
          border max-height="250" min-height="100">
          <el-table-column
            v-if="materialS.numChapters ? materialS.numChapters.length > 0 : false"
            prop="chapter"
            label="CAPÍTULO"
            fixed min-width="60%">
          </el-table-column>
          <el-table-column label="CÓDIGO DE DISCO" >
             <template slot-scope="scope">
              <div style="margin-left: 10px"
                v-for="(val, index) in scope.row.supportMaterial"
                :key="index">
                <p> {{ val.typeStorage || 'No ingresado'}}</p>
              </div>
            </template> 
          </el-table-column>
          <el-table-column prop="typeStorage" label="SOPORTE DE ALMACÉN" min-width="60%">
            <template slot-scope="scope">
              <div style="margin-left: 10px"
                v-for="(val, index) in scope.row.supportMaterial"
                :key="index">
                <p> {{ val.codeDisk || 'No ingresado' }}</p>
              </div>
            </template> 
          </el-table-column>
          <el-table-column prop="dateOfCopy" label="FECHA DE COPIADO" min-width="50%">
            <template slot-scope="scope">
              <div v-if="scope.row.dateOfCopy"> {{ transformDate(scope.row.dateOfCopy) }} </div>
              <div v-else> No ingresado </div>  
            </template>
          </el-table-column>
          <el-table-column prop="storages" label="ALMACENAMIENTO" min-width="90%">
            <template slot-scope="scope">
              <div>
                {{scope.row.storages || 'No ingresado'}}
              </div>
            </template>
          </el-table-column>
          <el-table-column
            v-if="whatTypeContentIsSame"
            prop="videoteca" 
            label="VIDEOTECA"></el-table-column>
          <el-table-column 
            prop="copyBackup" 
            label="BACK UP"
            min-width="50%">
            <template slot-scope="scope">
              <div>
                {{returnBackUpText(scope.row.copyBackup)}}
              </div>
            </template>
          </el-table-column>
          <el-table-column label="REPOSICIÓN">
            <template slot-scope="scope">
              <div v-if="scope.row.showreplace == 'REPOSICIÓN'" >
                <el-button size="mini" type="success"  plain  @click="showTableStora(scope.row)" >DETALLES </el-button> 
              </div>
            </template>
          </el-table-column>
        </el-table>

        <el-dialog :visible.sync="dialogStorage" width="80%">
          <div  style="margin:1rem 0 2rem"  >
            <h3 class="bolt-light"> <span class="text-red"> REPOSICIÓN -  </span> {{ materialS.originalTitle }}  </h3> 
          </div>
          <el-table :data="detallesByCap.reposicion" border  :header-cell-class-name="headerCellClassName">
            <el-table-column
              v-if="whatTypeContentIsDifferent"
               label="CAPÍTULO" fixed min-width="50%">
              <template slot-scope="scope">
                <div>  {{ detallesByCap.chapter }} </div>  
              </template>

            </el-table-column>
            <el-table-column label="ESTADO" min-width="60%">
                <template slot-scope="scope">
                  <div>  {{ detallesByCap.showreplace }} </div>  
              </template>
            </el-table-column>
            <el-table-column label="CÓDIGO DE DISCO">
              <template slot-scope="scope">
                <div style="margin-left: 10px"
                  v-for="(val, index) in scope.row.supportMaterial"
                  :key="index">
                  <p> {{ val.typeStorage || 'No ingresado' }}</p>
                </div>
              </template> 
            </el-table-column>
            <el-table-column label="SOPORTE DE ALMACÉN" min-width="50%">
               <template slot-scope="scope">
                <div style="margin-left: 10px"
                  v-for="(val, index) in scope.row.supportMaterial"
                  :key="index">
                  <p> {{ val.codeDisk || 'No ingresado'}}</p>
                </div>
              </template> 
            </el-table-column>
            <el-table-column property="dateOfCopy" label="FECHA DE COPIADO" min-width="45%">
              <template slot-scope="scope">
                <div v-if="scope.row.dateOfCopy"> {{ transformDate(scope.row.dateOfCopy) }} </div>
                <div v-else> No ingresado </div> 
              </template>
            </el-table-column>
            <el-table-column property="storages" label="ALMACENAMIENTO">
              <template slot-scope="scope">
                <div>
                  {{scope.row.storages || 'No ingresado'}}
                </div>
              </template>
            </el-table-column>
            <el-table-column property="videoteca" label="VIDEOTECA" v-if="whatTypeContentIsSame"></el-table-column>
            <!-- <el-table-column property="copyBackup" label="BACK UP" min-width="60%"></el-table-column> -->
            <!-- <el-table-column property="storages" label="ALMACENAMIENTO"></el-table-column> -->
            <el-table-column property="videoteca" label="VIDEOTECA" v-else></el-table-column>
            <el-table-column property="copyBackup" label="BACK UP" min-width="60%">
              <template slot-scope="scope">
                <div>
                  {{returnBackUpText(scope.row.copyBackup)}}
                </div>
              </template>
            </el-table-column>
          </el-table>
        </el-dialog>
      </div>
    </el-main>
  </div>
</template>
<style>
 .margin-Title {
    margin: 0.5rem 0;
 }
</style>
<script>

  import ReturnButton from '@/components/ReturnButton.vue'
  import SearchFilter from '@/components/searchFilter.vue'
  import autocomplete from '@/components/autocomplete.vue'
  import { convertDate } from '@/utils/calculateTime.js'
  import { modifyText } from '@/utils/modifyText.js'
  import {HTTP} from '@/main.js'

  export default {
    components: {
      ReturnButton,
      autocomplete,
      'app-search-filter': SearchFilter,
    },
    data () {
      return {
        // chapters: false,
        dialogTableVisible: false,
        dialogStorage:false,
        filterSelect: '',
        reviewObj: {},
        reception: [],
        receptionData: [],
        seleSeason: '',
        storageMat: [],
        storageData: [], // array de la tabla de almacenamiento reposicion
        textSearch: '',
        tableReception: [],
        tableStorage: [],
        links: [],
        idMaterial: '',
        itemHistory: JSON.parse(this.$localStorage.get("itemHistory")),
        //refactoring W
        materialsInContract: [],
        materialS: {},
       
        detallesByCap: {},
        // contrato: {},
        detallesStorageCap: {},
        arrSeason: [],
        materialName: '',
        productora: '',
        typeOfContent: '',
        itemConCapitulos: false,
        infoByMaterialSelected: [],
        contractName: '',
        text: `CÓDIGO DE <br>DISCO`
      }
    },
    created () {
      this.materialName = this.itemHistory.listTitle
      this.typeOfContent = this.itemHistory.typeOfContent
      this.productora = this.itemHistory.reviewObj ? this.itemHistory.reviewObj.arrProdCompany : []
      this.contractName = this.itemHistory.providerName
      this.getContracts()
      this.getMaterials()
    },
    methods: {
      getMaterials() {
        let dataType = 'materials'
        this.$store.dispatch('getData', dataType)
        let canned = []
        this.$store.state.materials.map((el) => {
          if (el.canned === true && el.listTitle !== null) {
            canned.push(el)
          }
        })
        this.links = canned
      },
      async getContracts () {
        console.log({contractCode: this.itemHistory.contractCode, itemHistory: this.itemHistory})
        // HTTP.get(`contracts/contractCode/${this.itemHistory.contractCode}`)
        //   .then(res => {
        //     this.materialsInContract = res.data.contract[0].admittedMaterials
        //     this.contractName = res.data.contract[0].contractName
        //     // this.infoByMaterialSelected = res.data.contract[0].admittedMaterials
        //     // this.contrato = res.data.contract
        //     this.materialSelectedInContract(res.data.contract[0].admittedMaterials)
        //     this.allSeasons()
        //   })
        //   .catch(err => console.log(err));

        let {data: {contract}} = await HTTP.get(`contracts/contractCode/${this.itemHistory.contractCode}`)
        
        // const {contract} = res.data
        console.log({contract})
        let {admittedMaterials, contractName} = contract[0]
        this.materialsInContract = admittedMaterials
        this.contractName = contractName
        this.materialSelectedInContract(admittedMaterials)
        this.allSeasons()
      },
       materialSelectedInContract (data) {
        data.map((el, i, arr) => {
          if(el._id === this.itemHistory.__id) {
            this.materialS = el
          }  
        })
      },
  
       allSeasons () {
         //
        if(this.materialS.numChapters !== undefined ) {
           this.arrSeason = []
           //
           this.materialS.numChapters.map((el) => {
           this.arrSeason.push({value: el.season, label:'Temporada ' + el.season}) })
           console.log(this.arrSeason, 'this.arrSeason')
        }     
      },
      // selectSeas(value) {
      //   this.tableReception = []
      //   this.tableStorage = []
      //   this.initTable(value)
      // },
      headerCellClassName ({row, column, rowIndex, columnIndex}) {
        
        if(rowIndex === 0 && column.label=== 'REPOSICIÓN' || column.label=== 'ESTADO'){
          return 'text-red bg-light-red'
        }
        if (rowIndex === 0) {
          return 'bg-light-red';
        } 
      },
      showTableStora ( index ) {
        this.detallesByCap = index
        this.dialogStorage = true
      },
      showTableRepo(index) {
        this.detallesByCap = index
        this.dialogTableVisible = true
      },
    
      returnPage() {
        this.$router.push({ name: 'recordCanned' })
      },
      eventInput (val) {
        if (val === '') {
          this.noCoincidence = false
        }
      },
      handleSelect(item) {
        this.itemHistory = item
        this.materialName = item.listTitle
        this.productora = item.reviewObj ? item.reviewObj.arrProdCompany : []
        this.typeOfContent = item.typeOfContent
        this.textSearch = item.listTitle
        this.idMaterial = item.__id
        this.filterSelect = ''
        this.getContracts()
      },
      querySearch(queryString, cb) {
        var links = this.links
        var results = queryString ? links.filter(this.createFilter(queryString)) : links
        this.noCoincidence = results.length === 0 ? true : false
        cb(results)
      },
      createFilter (queryString) {
        return (link) => {
          return (modifyText(link.listTitle).indexOf(modifyText(queryString)) === 0)
        }
      },
      transformDate(value) {
        if(value === '') {
          return 'No ingresado'
        } else {
          return new Date(value).toLocaleDateString('en-GB')
        }
      },
      returnBackUpText(val) {
        let response
        switch(val) {
          case 3:
            response = 'No'
          break;
          case 1: 
            response = 'Si'
          break;
          default:
            response = 'No copiado'
          break;
        }
        return response
      }
    },
    computed: {
      materialsData() {
        let exitInfoSupport = this.materialS.infoSupport? [this.materialS.infoSupport] : null
        let data = this.materialS.numChapters && this.materialS.numChapters.length > 0 ? this.materialS.numChapters[0].infoByChapter : exitInfoSupport
        let supportMaterialVacio = [{codeDisk: "No ingresado", typeStorage: "No ingresado"}]
        let transform
        if(data) {
          transform = data.map((e, i) => ({
            arrivalDate: !e.arrivalDate || e.arrivalDate == '' ? 'No ingresado' :new Date(e.arrivalDate).toLocaleDateString('en-GB'),
            arrivalSupport: e.arrivalSupport || 'No ingresado',
            chapter: e.chapter,
            copyBackup: e.copyBackup,
            dateOfCopy: e.dateOfCopy,
            guideNumber: e.guideNumber || 'No ingresado',
            hideChap: e.hideChap,
            nameCap: e.nameCap,
            replacement: e.replacement,
            replacementStorage:e.replacementStorage,
            reposicion: e.reposicion,
            shippingMode: e.shippingMode || 'No ingresado',
            showreplace: e.showreplace,
            state: e.state,
            statusChapter: e.statusChapter,
            statusStorageChap: e.statusStorageChap,
            storages: e.storages,
            supportMaterial: e.supportMaterial || supportMaterialVacio,
            validity: e.validity,
            videoteca: e.videoteca || 'No ingresado'
          }))
          

        }
        return transform ? transform : []
      },
      whatTypeContentIsSame() {
        let transform = this.typeOfContent.toUpperCase()
        if(transform == ('LARGOMETRAJES' || 'MINISERIES' || 'PROGRAMAS ESPECIALES' || 'ESPECIALES') ) {
          return true
        } else {
          return false
        }
      },
      whatTypeContentIsDifferent() {
        let transform = this.typeOfContent.toUpperCase()
        if(transform !== ('LARGOMETRAJES' || 'MINISERIES' || 'PROGRAMAS ESPECIALES' || 'ESPECIALES') ) {
          return true
        } else {
          return false
        }
      }
    }
  }
</script>

